Mellékleteink: HUP | Gamekapocs
Keres

Androidos fejlesztők kezére csap a Google

Gálffy Csaba, 2016. június 24. 14:10
Ez a cikk több évvel ezelőtt születetett, ezért előfordulhat, hogy a tartalma már elavult.
Frissebb anyagokat találhatsz a keresőnk segítségével:

A privát C/C++ könyvtárakhoz megszigorítja a hozzáférést az új Android kiadás.

Változik a "szürke zónába" tartozó C/C++ könyvtárakhoz való hozzáférés az Android következő verziójával - figyelmeztette a fejlesztőket a Google. A bejegyzés szerint az Android N-től fogva a fejlesztők kizárólag a hivatalos, publikus könyvtárakhoz férhetnek majd hozzá, a rendszer privát könyvtáraihoz többé egyáltalán nem.

Eszerint a publikus Android NDK (native development kit) részét képező libandroid, libc, libcamera2ndk, libdl, libGLES, libjnigraphics, liblog, libm, libmediandk, libOpenMAXAL, libOpenSLES, libstdc++, libvulkan és libz könyvtárak továbbra is hívhatóak maradnak, az Android többi C/C++ könyvtárhoz azonban kizárólag a platform HAL (hardware abstraction layer), a rendszer daemonok és különböző belső szolgáltatások férnek majd hozzá, a külső fejlesztői alkalmazások már nem. Ha valaki továbbra is ilyen szolgáltatásokat akar használni, akkor a könyvtárat mellékelnie kell az alkalmazáshoz.

A Google eddig ezt a területet lazán kezelte, a privát könyvtárak használatát elnézte a fejlesztőknek. A problémát az jelenti azonban a Google szerint, hogy ezek a könyvtárak nem minden eszközön találhatóak meg (vagy nem ugyanúgy működnek), és nem is képezik a hivatalos Android részét. Így a nagy androidos teszt, a Compatibility Test Suite sem tér ki ezekre, így nem is garantált, hogy minden Play Store-os eszközön futni tudnak.

Egy érdekes eset a C++ STL (standard template library), amely a jövőben szintén privátnak minősül. Ugyan három STL is része az Android NDK-nak, a hivatalos ajánlás szerint ezeket mellékelni kell az alkalmazással, nem lehet a rendszer részét képező STL-eket hívni, így erre érdemes lehet odafigyelni.

Az átállást megkönnyítendő, a Play Store-os alkalmazások által leggyakrabban használt könyvtárak használatát egy időre engedélyezi a Google (például a libandroid_runtime.so, libcutils.so, libcrypto.so, libssl.so), ezek támogatását rövid időre fenntarthatónak ítélte a cég. Az Android N API-ra (API level 24) nem frissített alkalmazások ezért elérik ezeket a könyvtárakat, de a Google mindenkit biztosít, hogy ez csak a következő Android-kiadásig lesz így. Az illegálisnak ítélt, de támogatott hívások az Android N fejlesztői kiadásában toast hibaüzenetet dobnak és futnak, a végleges kiadásban nem lesz majd hibaüzenet. A nem támogatott illegális hívások viszont egyáltalán nem fognak majd N alatt működni.

Facebook

Mit gondolsz? Mondd el!

Adatvédelmi okokból az adott hír megosztása előtt mindig aktiválnod kell a gombot! Ezzel a megoldással harmadik fél nem tudja nyomon követni a tevékenységedet a HWSW-n, ez pedig közös érdekünk.